using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SetMdbPass
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        /// <summary>
        // ---------------------------------------------------------
        // * Function  : btnRef_Click
        // * Event     : [Q]{^NbN 
        // * Last Modified on 2009/09/23 by Sunao-Laboratory
        // ---------------------------------------------------------
        /// </summary>
        private void btnRef_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            // --- mdbt@C
            ofd.FileName = "customer.mdb";
            // --- ftHgfBNg C:\ ɂ
            ofd.InitialDirectory = "C:\\";
            // --- [t@C̎]ɕ\Iw肷
            ofd.Filter = "mdbt@C(*.mdb)|*.mdb";
            ofd.FilterIndex = 1;
            // --- ^Cg
            ofd.Title = "customer.mdb̃pXw肵Ă";
            // --- _CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
            ofd.RestoreDirectory = true;
            ofd.CheckFileExists = true;
            ofd.CheckPathExists = true;

            // --- _CAO\
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                txtDBPath.Text = ofd.FileName;
            }
        }

        /// <summary>
        // ---------------------------------------------------------
        // * Function  : btnRegist_Click
        // * Event     : [o^]{^NbN 
        // * Last Modified on 2009/09/14 by Sunao-Laboratory
        // ---------------------------------------------------------
        /// </summary>
        private void btnRegist_Click(object sender, EventArgs e)
        {
            string strTitle = "Access2003 Ǘ߽ܰސݒ";
            string strPrompt = "Access2003 mdb Ǘ҃pX[hύX܂B낵łH";
            string strOldDBPath = txtDBPath.Text;
            string strTmpDBName = "tmp_" + System.IO.Path.GetFileName(strOldDBPath);
            string strTmpDBPath = System.IO.Path.GetDirectoryName(strOldDBPath) + "\\" + strTmpDBName;
            MessageBoxIcon msgIco = new  MessageBoxIcon();

            if (MessageBox.Show(strPrompt, strTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Question) == DialogResult.OK)
            {
                // --- Temporaly t@C݂폜
                if (System.IO.File.Exists(strTmpDBPath))
                {
                    System.IO.File.Delete(strTmpDBPath);
                }
                if (txtNewPasswd1.Text == txtNewPasswd2.Text)
                {
                    // --- œKJn
                    try
                    {
                        JRO.JetEngine jro = new JRO.JetEngine();

                        string OldDb = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + strOldDBPath +
                            ";Jet OLEDB:Database Password=" + txtOldPasswd.Text;
                        string NewDb = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + strTmpDBPath +
                            ";Jet OLEDB:Database Password=" + txtNewPasswd1.Text;

                        jro.CompactDatabase(OldDb, NewDb);              // --- œK
                        System.IO.File.Delete(strOldDBPath);            // --- DB̍폜
                        System.IO.File.Move(strTmpDBPath, strOldDBPath); // --- l[
                        strPrompt = "Ǘ҃pX[h̕ύX܂B";
                        msgIco = MessageBoxIcon.Information;
                    }
                    catch
                    {
                        strPrompt = "Ǘ҃pX[h̕ύXɎs܂B";
                        msgIco = MessageBoxIcon.Error;
                    }
                }
                else
                {
                    strPrompt = "VpX[hvĂ܂B";
                    msgIco = MessageBoxIcon.Warning;
                }
                MessageBox.Show(strPrompt, strTitle, System.Windows.Forms.MessageBoxButtons.OK, msgIco);
            }
        }

        /// <summary>
        // ---------------------------------------------------------
        // * Function  : btnClose_Click
        // * Event     : []{^NbN 
        // * Last Modified on 2009/09/14 by Sunao-Laboratory
        // ---------------------------------------------------------
        /// </summary>
        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}